// compiler avec gcc -g -Wall message.c -o message.ex
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
       
typedef void (*sighandler_t)(int);
#define nb_messages 5


const char * tab_messages[nb_messages] = {
	"Il faut affranchir nos compagnons",
	"Il faut franchir les compagnons",
	"Il faut rafraichir les maquignons",
	"Vous ne connaissez rien au code !!",
	"Il faut que vous fassiez blanchir des champignons"
};

const char * tab_processus[nb_messages] = {
	"Arthur",
	"Caradoc",
	"Perceval",
	"Lancelot",
	"Merlin"
};

/**
 * fonction de traitement des messages
 * @param num : le numero du processus
 * @param message : le message recu du précédant
 * @return le nouveau message
 */
const char* traite_message(int num, const char* message) {
	usleep(rand()%1000000);
	// pour le premier processus le message est simplement le premier de la liste
	if (num == 0) {
		fprintf(stderr, "%s : le message est '%s'\n", tab_processus[num], tab_messages[num]);
		return tab_messages[num];
	}
	// pour les autres, il faut vérifier qu'il n'a pas été modifié
	if (strcmp(tab_messages[num-1], message)!=0) {
		fprintf(stderr, "Attention, le message a été modifié, '%s' != '%s'\n", message, tab_messages[num-1]);
	}
	fprintf(stderr, "%s : le message est '%s'\n", tab_processus[num], tab_messages[num]);
	return tab_messages[num];
}



int main(int argc, char *argv[]) {
	int nb_processus = 5;
	
	// exemple génération message
	const char *mess = traite_message(0, NULL);
	// exemple traitement du message;
	const char *new_mess = traite_message(1, mess);
	
	return 0;
}
